(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global.phaxelf = {})));
}(this, (function (exports) { 'use strict';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();









var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var LocText = function (_Phaser$Text) {
  inherits(LocText, _Phaser$Text);
  function LocText(game, x, y, text) {
    var options = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    classCallCheck(this, LocText);
    var fontStyle = options.fontStyle || '30px Arial';
    var _this = possibleConstructorReturn(this, (LocText.__proto__ || Object.getPrototypeOf(LocText)).call(this, game, x, y, localization.get(text), {
      font: fontStyle,
      fill: options.fill || '#000',
      align: options.align || 'left'
    }));
    _this.lineSpacing = options.lineSpacing || 0;
    _this.$parseOptions(options);
    if (options.wordWrap) {
      _this.wordWrap = true;
      _this.wordWrapWidth = _this.$_maxWidth;
    }
    _this.anchor.x = options.aX === undefined || options.aX === null ? 0.5 : options.aX;
    _this.anchor.y = options.aY === undefined || options.aY === null ? 0.5 : options.aY;
    _this.$_localizationKey = text;
    _this.defaultFontSize = parseInt(fontStyle, 10) + '';
    _this.refit();
    _this.game.add.existing(_this);
    return _this;
  }
  createClass(LocText, [{
    key: '$parseOptions',
    value: function $parseOptions(options) {
      var padX = options.padX || 0;
      var padY = options.padY || 0;
      try {
        this.$_maxWidth = options.width || options.container.width - padX * 2;
        this.$_maxHeight = options.height || options.container.height - padY * 2;
      } catch (e) {
        throw new Error('Options should contain a width, height or container parameter');
      }
    }
  }, {
    key: 'refit',
    value: function refit() {
      if (!this.defaultFontSize) {
        this.defaultFontSize = this.fontSize.replace(/\D/g, '');
      }
      this.fontSize = this.defaultFontSize + 'pt';
      if (this.wordWrap) {
        this.textWidth = this.wordWrapWidth;
      }
      if (this.width > this.textWidth || this.height > this.textHeight) {
        var hSize = Math.floor(this.defaultFontSize * (this.textWidth / this.width));
        var vSize = Math.floor(this.defaultFontSize * (this.textHeight / this.height));
        this.fontSize = Math.min(vSize, hSize) + 'pt';
      }
    }
  }, {
    key: 'capitalize',
    value: function capitalize() {
      return this.charAt(0).toUpperCase() + this.slice(1);
    }
  }, {
    key: 'localizationKey',
    get: function get$$1() {
      return this.$_localizationKey;
    }
    ,
    set: function set$$1(value) {
      this.$_translationText = value;
      this.text = localization.get(value);
      this.refit();
    }
  }, {
    key: 'textWidth',
    get: function get$$1() {
      return this.$_maxWidth;
    }
    ,
    set: function set$$1(value) {
      this.$_maxWidth = value;
      this.wordWrapWidth = value;
      this.refit();
    }
  }, {
    key: 'textHeight',
    get: function get$$1() {
      return this.$_maxHeight;
    }
    ,
    set: function set$$1(value) {
      this.$_maxHeight = value;
      this.refit();
    }
  }]);
  return LocText;
}(Phaser.Text);

var Drag = function () {
  function Drag() {
    classCallCheck(this, Drag);
    throw new Error('StaticClassError');
  }
  createClass(Drag, null, [{
    key: "enable",
    value: function enable(subject) {
      var clampToCenter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (subject.inputEnabled !== undefined) {
        this.$enableSprite(subject, clampToCenter);
      } else {
        this.$enableGroup(subject, clampToCenter);
      }
    }
  }, {
    key: "bindEvent",
    value: function bindEvent(subject, eventName, callback, context) {
      subject.events[eventName].add(callback, context);
    }
  }, {
    key: "$enableSprite",
    value: function $enableSprite(subject) {
      var clampToCenter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      subject.inputEnabled = true;
      subject.input.enableDrag(clampToCenter);
      if (!clampToCenter) {
        subject.events.onDragStart.add(this.$onDragStart, subject);
      }
      subject.events.onDragUpdate.add(this.$onDragUpdate, subject);
    }
  }, {
    key: "$onDragStart",
    value: function $onDragStart(sprite, pointer) {
      sprite.$_inSpritePos = sprite.game.input.getLocalPosition(sprite, pointer);
      Drag.$onDragUpdate(sprite, pointer);
    }
  }, {
    key: "$onDragUpdate",
    value: function $onDragUpdate(sprite, pointer) {
      var pos = sprite.game.input.getLocalPosition(sprite.parent, pointer);
      if (sprite.$_inSpritePos) {
        sprite.x = pos.x - sprite.$_inSpritePos.x;
        sprite.y = pos.y - sprite.$_inSpritePos.y;
      } else {
        sprite.x = pos.x - sprite.width * (0.5 - sprite.anchor.x);
        sprite.y = pos.y - sprite.height * (0.5 - sprite.anchor.y);
      }
    }
  }, {
    key: "$enableGroup",
    value: function $enableGroup(subject) {
      throw new Error("Drag&drop with groups is buggy! Don't use it.");
    }
  }]);
  return Drag;
}();

var GeomSpr = function (_Phaser$Sprite) {
  inherits(GeomSpr, _Phaser$Sprite);
  function GeomSpr(game, x, y, type, path) {
    var opt = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    classCallCheck(this, GeomSpr);
    var _this = possibleConstructorReturn(this, (GeomSpr.__proto__ || Object.getPrototypeOf(GeomSpr)).call(this, game, x, y));
    _this.drawShape(type, path, opt);
    _this.game.add.existing(_this);
    return _this;
  }
  createClass(GeomSpr, [{
    key: 'drawShape',
    value: function drawShape(type, path, opt) {
      var bgColor = opt.bgColor === undefined || opt.bgColor === null ? 0xFFFFFF : opt.bgColor;
      var graphics = this.game.add.graphics(0, 0);
      graphics.beginFill(bgColor);
      if (opt.outLineData) {
        graphics.lineStyle(opt.outLineData.width, opt.outLineData.color, opt.outLineData.alpha);
      }
      if (type === 'rectangle' || type === 'circle' || type === 'polygon') {
        GeomSpr[type](path, graphics);
      } else {
        console.warn("Phaxelf-lib: Wrong shape type, try 'rectangle', 'circle' or 'polygon'...");
      }
      graphics.endFill();
      this.loadTexture(graphics.generateTexture());
      graphics.destroy();
      this.anchor.x = opt.aX === undefined || opt.aX === null ? 0.5 : opt.aX;
      this.anchor.y = opt.aY === undefined || opt.aY === null ? 0.5 : opt.aY;
      this.alpha = opt.alpha === undefined || opt.alpha === null ? 1 : opt.alpha;
      if (opt.parent) {
        opt.parent.addChild(this);
      }
    }
  }], [{
    key: 'polygon',
    value: function polygon(path, graphics) {
      var poly = path instanceof Phaser.Polygon ? path : new Phaser.Polygon(path);
      graphics.drawPolygon(poly.points);
    }
  }, {
    key: 'rectangle',
    value: function rectangle(path, graphics) {
      if (path instanceof Array) {
        graphics.drawRect(path[0], path[1], path[2], path[3]);
      } else if (path instanceof Phaser.Rectangle) {
        graphics.drawRect(path.x, path.y, path.width, path.height);
      } else {
        console.warn('Phaxelf: Trying to build a rectangle with a wrong path format.');
      }
    }
  }, {
    key: 'circle',
    value: function circle(path, graphics) {
      if (path instanceof Array) {
        graphics.drawCircle(path[0], path[1], path[2]);
      } else if (path instanceof Phaser.Circle) {
        graphics.drawCircle(path.x, path.y, path.diameter);
      } else {
        console.warn('Phaxelf: Trying to build a circle with a wrong path format.');
      }
    }
  }]);
  return GeomSpr;
}(Phaser.Sprite);

var OverlaySpr = function (_Phaser$Sprite) {
  inherits(OverlaySpr, _Phaser$Sprite);
  function OverlaySpr(game, x, y, width, height) {
    var path = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
    var opt = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};
    classCallCheck(this, OverlaySpr);
    var _this = possibleConstructorReturn(this, (OverlaySpr.__proto__ || Object.getPrototypeOf(OverlaySpr)).call(this, game, x, y));
    _this.$width = width;
    _this.$height = height;
    _this.alpha = opt.alpha === undefined || opt.alpha === null ? 0.5 : opt.alpha;
    var bgColor = opt.bgColor === undefined || opt.bgColor === null ? 0x000000 : opt.bgColor;
    _this.$graphics = game.add.graphics(0, 0);
    _this.$graphics.beginFill(bgColor);
    if (path instanceof Phaser.Polygon) _this.setHighlightPolygon(path, opt.anticlockwise);else if (path instanceof Phaser.Rectangle) _this.setHighlightRect(path);else if (path instanceof Phaser.Circle) _this.setHighlightCircle(path);else if (!path) _this.$graphics.drawRect(0, 0, _this.$width, _this.$height);else console.warn('Phaxelf-lib: Wrong path format, try instances of Phaser.Rectangle, Phaser.Circle or Phaser.Polygon...');
    _this.$graphics.endFill();
    _this.loadTexture(_this.$graphics.generateTexture());
    _this.$graphics.destroy();
    game.add.existing(_this);
    return _this;
  }
  createClass(OverlaySpr, [{
    key: 'setHighlightPolygon',
    value: function setHighlightPolygon(polygon) {
      var _this2 = this;
      var anticlockwise = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var points = [new Phaser.Point(0, 0), new Phaser.Point(0, this.$height), new Phaser.Point(this.$width, this.$height), new Phaser.Point(this.$width, 0), new Phaser.Point(0, 0)];
      if (anticlockwise) points.reverse();
      polygon.points = polygon.points.map(function (point) {
        return Phaser.Point.subtract(point, _this2.position);
      });
      points = polygon.points.concat(points);
      this.$graphics.drawPolygon(points);
    }
  }, {
    key: 'setHighlightRect',
    value: function setHighlightRect(rectangle) {
      var points = [Phaser.Point.subtract(rectangle.topLeft, this.position), Phaser.Point.subtract(rectangle.bottomLeft, this.position), Phaser.Point.subtract(rectangle.bottomRight, this.position), Phaser.Point.subtract(rectangle.topRight, this.position), Phaser.Point.subtract(rectangle.topLeft, this.position), new Phaser.Point(0, 0), new Phaser.Point(this.$width, 0), new Phaser.Point(this.$width, this.$height), new Phaser.Point(0, this.$height), new Phaser.Point(0, 0)];
      this.$graphics.drawPolygon(points);
    }
  }, {
    key: 'setHighlightCircle',
    value: function setHighlightCircle(circle) {
      this.$graphics.arc(circle.x - this.x, circle.y - this.y, circle.radius, Math.PI, Math.PI * 3);
      this.$graphics.lineTo(0, 0);
      this.$graphics.lineTo(0, 0);
      this.$graphics.lineTo(0, this.$height);
      this.$graphics.lineTo(this.$width, this.$height);
      this.$graphics.lineTo(this.$width, 0);
      this.$graphics.lineTo(0, 0);
    }
  }]);
  return OverlaySpr;
}(Phaser.Sprite);

var RectangleOverlay = function (_Geom) {
  inherits(RectangleOverlay, _Geom);
  function RectangleOverlay(game, x, y, width, height) {
    var opt = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    classCallCheck(this, RectangleOverlay);
    var path = new Phaser.Rectangle(x, y, width, height);
    var options = {
      aX: opt.aX,
      aY: opt.aY,
      bgColor: 0x000000
    };
    options.alpha = opt.alpha === undefined || opt.alpha === null ? 0.5 : opt.alpha;
    var _this = possibleConstructorReturn(this, (RectangleOverlay.__proto__ || Object.getPrototypeOf(RectangleOverlay)).call(this, game, x, y, 'rectangle', path, options));
    game.add.existing(_this);
    return _this;
  }
  createClass(RectangleOverlay, [{
    key: 'hide',
    value: function hide() {
      this.visible = false;
    }
  }, {
    key: 'show',
    value: function show() {
      this.visible = true;
    }
  }, {
    key: 'addHighlightCircle',
    value: function addHighlightCircle(x, y, diameter) {
      this.customMask = new GeomSpr(this.game, x, y, 'circle', [0, 0, diameter]);
    }
  }, {
    key: 'addHighlightRect',
    value: function addHighlightRect(x, y, width, height) {
      this.customMask = new GeomSpr(this.game, x, y, 'rectangle', [x, y, width, height]);
    }
  }, {
    key: 'addHighlightCustom',
    value: function addHighlightCustom(x, y, mask) {
      this.customMask = mask;
    }
  }, {
    key: 'removeHightlight',
    value: function removeHightlight() {
      var destroyMask = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      this.mask = null;
      if (destroyMask) {
        this.$mask.destroy();
      }
    }
  }, {
    key: 'customMask',
    set: function set$$1(mask) {
      this.$mask = mask;
      this.addChild(this.$mask);
      this.mask = this.$mask;
    },
    get: function get$$1() {
      return this.$mask;
    }
  }]);
  return RectangleOverlay;
}(GeomSpr);

var CoordinatesHelper = function () {
  function CoordinatesHelper() {
    classCallCheck(this, CoordinatesHelper);
    throw new Error('StaticClassError');
  }
  createClass(CoordinatesHelper, null, [{
    key: 'transformCoordinates',
    value: function transformCoordinates(source, destination) {
      var reference = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Phaser.Point(0.5, 0.5);
      var sourceTree = this.getTree(source);
      var destinationTree = this.getTree(destination);
      var commonAncestor = this.findCommonAncestor(sourceTree, destinationTree);
      var parentPosition = this.pointInAncestor(source, commonAncestor, reference);
      var toPosition = this.pointInDescendant(parentPosition, commonAncestor, destination);
      return toPosition;
    }
  }, {
    key: 'contains',
    value: function contains(point, sprite) {
      return point.x >= sprite.x - sprite.anchor.x * sprite.width && point.x < sprite.x + sprite.anchor.x * sprite.width && point.y >= sprite.y - sprite.anchor.y * sprite.height && point.y <= sprite.y + sprite.anchor.y * sprite.height;
    }
  }, {
    key: 'pointInAncestor',
    value: function pointInAncestor(sprite, ancestor) {
      var pivot = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Phaser.Point(0.5, 0.5);
      var coordinates = new Phaser.Point(this.getPositionX(sprite, pivot.x, true), this.getPositionY(sprite, pivot.y, true));
      var current = sprite;
      while (current.parent !== ancestor) {
        current = current.parent;
        var withScale = current.parent !== ancestor;
        coordinates.x += this.getPositionX(current, pivot.x, withScale);
        coordinates.y += this.getPositionY(current, pivot.y, withScale);
      }
      return coordinates;
    }
  }, {
    key: 'pointInDescendant',
    value: function pointInDescendant(point, reference, descendant) {
      var coordinates = new Phaser.Point(point.x, point.y);
      var tree = [];
      var current = descendant.parent;
      while (current !== reference) {
        tree.push(current);
        current = current.parent;
        if (!current) {
          throw new Error('`reference` is not an ancestor of `descendant`');
        }
      }
      for (var i = tree.length - 1; i >= 0; i -= 1) {
        var element = tree[i];
        coordinates.x = (coordinates.x - element.x) / element.scale.x;
        coordinates.y = (coordinates.y - element.y) / element.scale.y;
      }
      return coordinates;
    }
  }, {
    key: 'sizeInAncestor',
    value: function sizeInAncestor(sprite, ancestor) {
      var size = new Phaser.Point(sprite.width, sprite.height);
      var current = sprite;
      while (current.parent !== ancestor) {
        size.x *= current.parent.scale.x;
        size.y *= current.parent.scale.y;
        current = current.parent;
      }
      return size;
    }
  }, {
    key: 'getTree',
    value: function getTree(element) {
      var parents = [];
      while (element.parent != null) {
        element = element.parent;
        parents.push(element);
      }
      return parents;
    }
  }, {
    key: 'findCommonAncestor',
    value: function findCommonAncestor(tree1, tree2) {
      for (var i = 0; i < tree1.length; i += 1) {
        var el1 = tree1[i];
        for (var j = 0; j < tree2.length; j += 1) {
          var el2 = tree2[j];
          if (el1 === el2) {
            return el1;
          }
        }
      }
      return null;
    }
  }, {
    key: 'getPositionX',
    value: function getPositionX(object, referenceX) {
      var withScale = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var x = object.x + (object.anchor ? referenceX - object.anchor.x : 0) * object.width;
      if (withScale && object.parent) {
        return x * object.parent.scale.x;
      }
      return x;
    }
  }, {
    key: 'getPositionY',
    value: function getPositionY(object, referenceY) {
      var withScale = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var y = object.y + (object.anchor ? referenceY - object.anchor.y : 0) * object.height;
      if (withScale && object.parent) {
        return y * object.parent.scale.y;
      }
      return y;
    }
  }]);
  return CoordinatesHelper;
}();

var TweenUtils = function () {
  function TweenUtils() {
    classCallCheck(this, TweenUtils);
  }
  createClass(TweenUtils, null, [{
    key: "tint",
    value: function tint(subject, _tint, duration) {
      var easing = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : Phaser.Easing.Default;
      var autostart = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      var delay = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
      var repeat = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 0;
      var yoyo = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;
      var colorBlend = { step: 0 };
      var initialTint = subject.tint;
      return subject.game.add.tween(colorBlend).to({ step: 100 }, duration, easing, autostart, delay, repeat, yoyo).onUpdateCallback(function () {
        subject.tint = Phaser.Color.interpolateColor(initialTint, _tint, 100, colorBlend.step, 1);
      });
    }
  }]);
  return TweenUtils;
}();

var SpritePool = function (_Array) {
  inherits(SpritePool, _Array);
  function SpritePool(key, initialAmount, settingsAction) {
    var _ref;
    classCallCheck(this, SpritePool);
    for (var _len = arguments.length, sprites = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
      sprites[_key - 3] = arguments[_key];
    }
    var _this = possibleConstructorReturn(this, (_ref = SpritePool.__proto__ || Object.getPrototypeOf(SpritePool)).call.apply(_ref, [this].concat(sprites)));
    _this.$key = key;
    _this.$settingsAction = settingsAction;
    _this.$createSprite = function () {
      var sprite = void 0;
      if (_this.$key instanceof Array) {
        var totalWeight = 0;
        var currentWeight = 0;
        var winnerElement = null;
        _this.$key.forEach(function (el) {
          totalWeight = el.weight !== undefined ? totalWeight + el.weight : totalWeight + 1;
        });
        var random = Math.random() * totalWeight;
        _this.$key.some(function (el) {
          currentWeight = el.weight !== undefined ? currentWeight + el.weight : currentWeight + 1;
          if (currentWeight >= random) {
            winnerElement = el;
            return true;
          }
          return false;
        });
        var frame = winnerElement.frameName ? winnerElement.frameName : winnerElement;
        sprite = imageLoader.sprite(0, 0, frame);
      } else {
        sprite = imageLoader.sprite(0, 0, _this.$key);
      }
      sprite.visible = false;
      _this.$settingsAction(sprite);
      _this.push(sprite);
    };
    for (var i = 0; i < initialAmount; i += 1) {
      _this.$createSprite();
    }
    _this.getSprite = function () {
      if (_this.length < 1) _this.$createSprite();
      var sprite = _this.pop();
      sprite.visible = true;
      return sprite;
    };
    _this.addSprite = function (sprite) {
      sprite.visible = false;
      _this.$settingsAction(sprite);
      _this.push(sprite);
    };
    return _this;
  }
  return SpritePool;
}(Array);

var CoordinatesExtension = function () {
  function CoordinatesExtension() {
    classCallCheck(this, CoordinatesExtension);
    throw new Error('StaticClassError');
  }
  createClass(CoordinatesExtension, null, [{
    key: 'init',
    value: function init(LU) {
      this.LU = LU;
      this.extendSprite();
      this.extendGraphics();
      this.extendGroup();
    }
  }, {
    key: 'extendSprite',
    value: function extendSprite() {
      Phaser.Sprite.prototype.$$centered = this.phaserSpriteCentered;
      Phaser.Sprite.prototype.$$moveTo = this.phaserSpriteMoveTo;
      Phaser.Sprite.prototype.$$pointIn = this.phaserSpritePointIn;
      Phaser.Sprite.prototype.$$contains = this.phaserSpriteContains;
    }
  }, {
    key: 'extendGraphics',
    value: function extendGraphics() {
      Phaser.Graphics.prototype.$$centered = this.phaserSpriteCentered;
      Phaser.Graphics.prototype.$$moveTo = this.phaserSpriteMoveTo;
      Phaser.Graphics.prototype.$$pointIn = this.phaserSpritePointIn;
    }
  }, {
    key: 'extendGroup',
    value: function extendGroup() {
      Phaser.Group.prototype.$$centered = this.phaserSpriteCentered;
      Phaser.Group.prototype.$$moveTo = this.phaserSpriteMoveTo;
      Phaser.Group.prototype.$$pointIn = this.phaserSpritePointIn;
    }
  }, {
    key: 'phaserSpriteCentered',
    value: function phaserSpriteCentered() {
      var anchor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Phaser.Point(0.5, 0.5);
      this.anchor = anchor;
      this.position = new Phaser.Point(CoordinatesExtension.LU.BASE_WIDTH / 2, CoordinatesExtension.LU.BASE_HEIGHT / 2);
    }
  }, {
    key: 'phaserSpriteMoveTo',
    value: function phaserSpriteMoveTo(destination) {
      var anchor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new Phaser.Point(0.5, 0.5);
      this.position = CoordinatesHelper.transformCoordinates(destination, this, anchor);
    }
  }, {
    key: 'phaserSpritePointIn',
    value: function phaserSpritePointIn(ancestor) {
      var anchor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new Phaser.Point(0.5, 0.5);
      return CoordinatesHelper.pointInAncestor(this, ancestor, anchor);
    }
  }, {
    key: 'phaserSpriteContains',
    value: function phaserSpriteContains(point) {
      return CoordinatesHelper.contains(point, this);
    }
  }]);
  return CoordinatesExtension;
}();

var TweensExtension = function () {
  function TweensExtension() {
    classCallCheck(this, TweensExtension);
    throw new Error('StaticClassError');
  }
  createClass(TweensExtension, null, [{
    key: 'init',
    value: function init() {
      this.extendSprite();
      this.extendGraphics();
      this.extendGroup();
    }
  }, {
    key: 'extendSprite',
    value: function extendSprite() {
      Phaser.Sprite.prototype.$$tween = this.phaserTweenShortcut;
      Phaser.Sprite.prototype.$$scaleTween = this.phaserScaleTweenShortcut;
      Phaser.Sprite.prototype.$$tintTween = this.phaserTintTweenShortcut;
    }
  }, {
    key: 'extendGroup',
    value: function extendGroup() {
      Phaser.Group.prototype.$$tween = this.phaserTweenShortcut;
    }
  }, {
    key: 'extendGraphics',
    value: function extendGraphics() {
      Phaser.Graphics.prototype.$$tween = this.phaserTweenShortcut;
      Phaser.Graphics.prototype.$$scaleTween = this.phaserScaleTweenShortcut;
    }
  }, {
    key: 'phaserTweenShortcut',
    value: function phaserTweenShortcut(properties, duration) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var ease = options.ease,
          autostart = options.autostart,
          delay = options.delay,
          repeat = options.repeat,
          yoyo = options.yoyo;
      return this.game.add.tween(this).to(properties, duration, ease, autostart, delay, repeat, yoyo);
    }
  }, {
    key: 'phaserScaleTweenShortcut',
    value: function phaserScaleTweenShortcut(properties, duration) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var ease = options.ease,
          autostart = options.autostart,
          delay = options.delay,
          repeat = options.repeat,
          yoyo = options.yoyo;
      return this.game.add.tween(this.scale).to(properties, duration, ease, autostart, delay, repeat, yoyo);
    }
  }, {
    key: 'phaserTintTweenShortcut',
    value: function phaserTintTweenShortcut(tint, duration) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var ease = options.ease,
          autostart = options.autostart,
          delay = options.delay,
          repeat = options.repeat,
          yoyo = options.yoyo;
      return TweenUtils.tint(this, tint, duration, ease, autostart, delay, repeat, yoyo);
    }
  }]);
  return TweensExtension;
}();

var Extensions = function () {
  function Extensions() {
    classCallCheck(this, Extensions);
    throw new Error('StaticClassError');
  }
  createClass(Extensions, null, [{
    key: 'init',
    value: function init(LU) {
      TweensExtension.init();
      CoordinatesExtension.init(LU);
    }
  }]);
  return Extensions;
}();

exports.LocText = LocText;
exports.Drag = Drag;
exports.CoordinatesHelper = CoordinatesHelper;
exports.Geom = GeomSpr;
exports.Overlay = OverlaySpr;
exports.RectOverlay = RectangleOverlay;
exports.TweenUtils = TweenUtils;
exports.Extensions = Extensions;
exports.SpritePool = SpritePool;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=phaxelf.js.map
